function T = dynamic_g1_tt(T, y, x, params, steady_state, it_)
% function T = dynamic_g1_tt(T, y, x, params, steady_state, it_)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double  vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double  vector of endogenous variables in the order stored
%                                                    in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double  matrix of exogenous variables (in declaration order)
%                                                    for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double  vector of steady state values
%   params        [M_.param_nbr by 1]        double  vector of parameter values in declaration order
%   it_           scalar                     double  time period for exogenous variables for which
%                                                    to evaluate the model
%
% Output:
%   T           [#temp variables by 1]       double  vector of temporary terms
%

assert(length(T) >= 79);

T = dw_AF13.dynamic_resid_tt(T, y, x, params, steady_state, it_);

T(38) = (-T(2))/(y(40)*y(40));
T(39) = (-(y(48)*(-(1-y(27)))/(y(27)*(1-y(48)))));
T(40) = (-y(11))/(y(1)*y(1));
T(41) = 1/y(1);
T(42) = exp(y(38))*getPowerDeriv(y(11),params(4),1);
T(43) = (-y(14))/(y(12)*y(12));
T(44) = getPowerDeriv(T(1),(-params(9)),1);
T(45) = getPowerDeriv(T(1),1-params(9),1);
T(46) = 1/y(12);
T(47) = 1/T(6);
T(48) = (-y(19))/(y(3)*y(3));
T(49) = getPowerDeriv(y(19)/y(3),params(8),1);
T(50) = T(34)*T(48)*T(49);
T(51) = getPowerDeriv(T(36),1-params(6),1);
T(52) = T(34)*T(49)*1/y(3);
T(53) = getPowerDeriv(y(21),1-params(4),1);
T(54) = (-y(23))/(y(5)*y(5));
T(55) = 1/y(5);
T(56) = (-y(46))/(y(23)*y(23));
T(57) = 2*y(46)/y(23);
T(58) = T(57)*1/y(23);
T(59) = getPowerDeriv(y(24),params(11),1);
T(60) = (-(y(18)*T(59)))/(T(6)*T(6));
T(61) = params(1)/params(2)*getPowerDeriv(y(24),params(7),1);
T(62) = getPowerDeriv(y(47),1+params(11),1);
T(63) = (-((-(y(53)*params(2)*y(36)*exp(y(39))/params(1)))/(y(47)*y(47))));
T(64) = (-((y(27)*(1-y(48))*y(48)*(-(1-y(41)))-(1-y(41))*(1-y(27))*y(48)*(1-y(48)))/(y(27)*(1-y(48))*y(27)*(1-y(48)))));
T(65) = (-(((1-y(41))*(1-y(27))*y(27)*(1-y(48))-(1-y(41))*(1-y(27))*y(48)*(-y(27)))/(y(27)*(1-y(48))*y(27)*(1-y(48)))));
T(66) = getPowerDeriv(y(6),params(6),1);
T(67) = exp((-params(25))*x(it_, 3))*T(66);
T(68) = (-(y(53)*params(2)*exp(y(39))/params(1)/y(47)));
T(69) = params(29)*(-((1-params(30))*params(2)*y(53)))/(y(37)*y(37))/y(53);
T(70) = T(69)/y(40);
T(71) = (-(params(2)*y(53)))/(y(37)*y(37));
T(72) = (-((1-params(30))*params(2)*y(53)))/(y(37)*y(37))/params(1);
T(73) = y(49)*params(2)*(-y(53))/(y(37)*y(37));
T(74) = y(53)*params(29)*(1-params(30))*params(2)/y(37)-params(29)*(1-params(30))*params(2)*y(53)/y(37);
T(75) = T(74)/(y(53)*y(53));
T(76) = T(75)/y(40);
T(77) = params(2)/y(37);
T(78) = (1-params(30))*params(2)/y(37)/params(1);
T(79) = (-(params(2)*y(36)*exp(y(39))/params(1)/y(47)));

end
