function T = dynamic_resid_tt(T, y, x, params, steady_state, it_)
% function T = dynamic_resid_tt(T, y, x, params, steady_state, it_)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double  vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double  vector of endogenous variables in the order stored
%                                                    in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double  matrix of exogenous variables (in declaration order)
%                                                    for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double  vector of steady state values
%   params        [M_.param_nbr by 1]        double  vector of parameter values in declaration order
%   it_           scalar                     double  time period for exogenous variables for which
%                                                    to evaluate the model
%
% Output:
%   T           [#temp variables by 1]       double  vector of temporary terms
%

assert(length(T) >= 37);

T(1) = y(14)/y(12);
T(2) = params(29)*(1-params(30))*params(2)*y(53)/y(37)/y(53);
T(3) = T(2)/y(40);
T(4) = params(2)*y(53)/y(37);
T(5) = y(11)^2;
T(6) = y(24)^params(11);
T(7) = (1-params(30))*params(2)*y(53)/y(37)/params(1);
T(8) = y(44)^2;
T(9) = y(47)^(1+params(11));
T(10) = 1-(1-y(41))*(1-y(27))*y(48)/(y(27)*(1-y(48)));
T(11) = y(33)*y(20)-y(31)/y(1)+T(3)*T(10);
T(12) = y(51)*y(53)*params(2)*y(27)/y(37);
T(13) = y(42)*T(12);
T(14) = (params(19)-1)/2;
T(15) = y(11)/y(1)-1;
T(16) = 1/params(20)^2;
T(17) = 1/params(20);
T(18) = (params(14)-1)/2;
T(19) = y(18)/T(6)-params(1);
T(20) = 1/params(15)^2;
T(21) = 1/params(15);
T(22) = exp(y(38))*y(11)^params(4);
T(23) = y(21)^(1-params(4));
T(24) = (params(16)-1)/2;
T(25) = y(23)/y(5)-1;
T(26) = 1/params(18)^2;
T(27) = 1/params(18);
T(28) = params(2)*y(53)/y(37);
T(29) = T(28)*y(49);
T(30) = (y(46)/y(23))^2;
T(31) = y(53)*params(2)*y(36)*exp(y(39))/params(1)/y(47);
T(32) = y(6)^params(6);
T(33) = exp((-params(25))*x(it_, 3))*T(32);
T(34) = params(1)/params(2)*y(24)^params(7);
T(35) = (y(19)/y(3))^params(8);
T(36) = T(34)*T(35);
T(37) = T(36)^(1-params(6));

end
