function [fis,fpt]= isturnpoint(y, turnphase)
%  [fis,fpt]= isdate(y, turnphase)
%
%  Determines if a data point is a potential turning point

% IEB: outputs of this function include: 'fis', for whetehr a data point is 
% a turning point; 'fpt', if it is a peak or trough. 'fis' is binary (0 not
% a turning point; 1 for turning point); 'fpt, (1 for peak; -1 for trough);
% Inputs: 'y', time series data array; 'turnphase', a paramter which 
% indiates the distance before and after each data point to determine if it 
% is a turning point.


% IEB: create a zero vector with lenght of turnphase*2 - hold results of
% comparison test
adf=zeros(turnphase*2,1);

% IEB: set i as the point in the middle of a turnphase that is being 
% analyzed. 'turnphase' is how many points before and after a specific data
% point that must be considered to determine whether the specific data
% point is a turning point. So to include the point itself, one would set 
% it to i=turnphase +1, which would be the point considered in the middle of the
% entire turnphase (this is becasue we look at the turnphase lenght before
% and after the point).

%IEB: initialized to zero
fis=0;
fpt=0;

% IEB: a loop that checks for peaks by comparing each 'mid' point, i in
% a specified segment of the data - through the paramter 'turnphase'- with
% every other point in that segment. loop runs from q=1, to 'turnphase*2
% +1'
       q=1;
       qq=1;
         while q<=turnphase*2+1;
              if q~=i;
% IEB: if the difference between each point q and mid point i is less than
% or equal to zero, entry in adf is 1. Then q and qq incrementally increase
% by 1.
      adf(qq) = indicat(y(q)-y(i));
           qq=qq+1;
         end;
       q=q+1;
     end;
       p1=sum(adf);

% IEB: if sum of adf vector is equal to turnphase* 2, this means that all
% points in the segment are less than or equal to the mid point, so it is a
% peak. Thus fis=1 (it is a turning point), and fpt=1 (it is a peak).
      if p1==turnphase*2;
       fis=1;
       fpt=1;
     end;

% IEB: Similar loop process as above, but to identify troughs, where the
% any point q in a segment is greater than or equal to the considered mid 
% point.
       q=1;
       qq=1;
         while q<=turnphase*2+1;
          if q~=i;

        adf(qq) = indicat(y(i)-y(q)); 
           qq=qq+1;
         end;
       q=q+1;
     end;
       p1=sum(adf);
      if p1==turnphase*2;
       fis=1;
       fpt=-1;
     end;


% End of function






